//+------------------------------------------------------------------+
//|                                              .mq4 |
//|                               Copyright  2011,   |
//|                                                cmillion@narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, http://cmillion.narod.ru"
#property link      "cmillion@narod.ru"
//--------------------------------------------------------------------
extern string  MA1="";     
extern int     period_1             = 5,           //     MA.
               ma_shift_1           = 0,           //    .
               ma_method_1          = MODE_EMA,    // .         (Moving Average).
                                                   //MODE_SMA 0    
                                                   //MODE_EMA 1    
                                                   //MODE_SMMA 2    
                                                   //MODE_LWMA 3 -   

               applied_price_1      = PRICE_OPEN,  // .      .
                                                   //PRICE_CLOSE 0   
                                                   //PRICE_OPEN 1   
                                                   //PRICE_HIGH 2   
                                                   //PRICE_LOW 3   
                                                   //PRICE_MEDIAN 4  , (high+low)/2 
                                                   //PRICE_TYPICAL 5  , (high+low+close)/3 
                                                   //PRICE_WEIGHTED 6   , (high+low+close+close)/4 

               timeframe_1          = 0;           //.      . 0    .
extern string  MA2="";     
extern int     period_2             = 30,          //     MA.
               ma_shift_2           = 0,           //    .
               ma_method_2          = MODE_LWMA,   // .         (Moving Average).
               applied_price_2      = PRICE_OPEN,  // .      .
               timeframe_2          = 0;           //.      . 0    .
extern string  MA3="";     
extern int     period_3             = 100,         //     MA.
               ma_shift_3           = 0,           //    .
               ma_method_3          = MODE_LWMA,   // .         (Moving Average).
               applied_price_3      = PRICE_OPEN,  // .      .
               timeframe_3          = 0;           //.      . 0    .
extern string  .="";     
extern int     stoploss             = 0,           //
               takeprofit           = 0,           //
               TrailingStop         = 0,           //,  0,   
               NoLoss               = 0,           //  ,  0,     
               MaxOrders            = 1;           // -    
extern double  LOT                  = 0.1;         // 
extern bool    CloseRevers          = true;        //    
//--------------------------------------------------------------------
int TimeBar,STOPLEVEL,Magic=1234567890;
//--------------------------------------------------------------------
int start()
{
   STOPLEVEL=MarketInfo(Symbol(),MODE_STOPLEVEL);
   if (TrailingStop>=STOPLEVEL) TrailingStop();
   if (NoLoss>=STOPLEVEL) NoLoss();
   if (TimeBar==Time[0]) return(0);

   double MA10 = NormalizeDouble(iMA(NULL,timeframe_1,period_1,ma_shift_1,ma_method_1,applied_price_1,0),Digits);
   double MA11 = NormalizeDouble(iMA(NULL,timeframe_1,period_1,ma_shift_1,ma_method_1,applied_price_1,1),Digits);
   double MA20 = NormalizeDouble(iMA(NULL,timeframe_2,period_2,ma_shift_2,ma_method_2,applied_price_2,0),Digits);
   double MA21 = NormalizeDouble(iMA(NULL,timeframe_2,period_2,ma_shift_2,ma_method_2,applied_price_2,1),Digits);
   double MA3  = NormalizeDouble(iMA(NULL,timeframe_3,period_3,ma_shift_3,ma_method_3,applied_price_3,0),Digits);

   ObjectDelete("MA10");
   ObjectCreate("MA10",OBJ_ARROW,0,Time[0],MA10,0,0,0,0);                     
   ObjectSet   ("MA10",OBJPROP_ARROWCODE,6);
   ObjectSet   ("MA10",OBJPROP_COLOR, Blue); 
   ObjectDelete("MA20");
   ObjectCreate("MA20",OBJ_ARROW,0,Time[0],MA20,0,0,0,0);                     
   ObjectSet   ("MA20",OBJPROP_ARROWCODE,6);
   ObjectSet   ("MA20",OBJPROP_COLOR, Blue); 
   
   double SL,TP;
   if (MA10>=MA20&&MA11<MA21&&MA20>=MA3)
   {
      if (CloseRevers) CLOSEORDER(OP_SELL);
      if (MaxOrders>OrdersTotal())       
      {
         if (takeprofit!=0) TP  = NormalizeDouble(Ask + takeprofit*Point,Digits); else TP = 0;
         if (stoploss!=0)   SL  = NormalizeDouble(Bid - stoploss*Point,Digits); else SL = 0;
         if (OrderSend(Symbol(),OP_BUY, LOT,NormalizeDouble(Ask,Digits),2,SL,TP," ",Magic,3)!=-1) TimeBar=Time[0]; 
         else Print("OrderSend BUY Error ",GetLastError(),"  SL ",SL,"  TP ",TP);
      }
   }
   if (MA10<=MA20&&MA11>MA21&&MA20<=MA3)
   {
      if (CloseRevers) CLOSEORDER(OP_BUY);
      if (MaxOrders>OrdersTotal()) 
      {
         if (takeprofit!=0) TP = NormalizeDouble(Bid - takeprofit*Point,Digits); else TP = 0;
         if (stoploss!=0)   SL = NormalizeDouble(Ask + stoploss*Point,Digits); else SL = 0;
         if (OrderSend(Symbol(),OP_SELL,LOT,NormalizeDouble(Bid,Digits),2,SL,TP," ",Magic,3)!=-1) TimeBar=Time[0]; 
         else Print("OrderSend SELL Error ",GetLastError(),"  SL ",SL,"  TP ",TP);
      }
   }
return(0);
}
//--------------------------------------------------------------------
void CLOSEORDER(int ord)
{
   for (int i=0; i<OrdersTotal(); i++)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            if (OrderType()==OP_BUY && ord==OP_BUY)
               OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),3,CLR_NONE);
            if (OrderType()==OP_SELL && ord==OP_SELL)
               OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),3,CLR_NONE);
         }
      }   
   }
}
//--------------------------------------------------------------------
void TrailingStop()
{
   int tip,Ticket;
   double StLo,OSL,OOP;
   for (int i=0; i<OrdersTotal(); i++) 
   {  if (OrderSelect(i, SELECT_BY_POS))
      {  tip = OrderType();
         if (tip<2 && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            OSL   = NormalizeDouble(OrderStopLoss(),Digits);
            OOP   = NormalizeDouble(OrderOpenPrice(),Digits);
            Ticket = OrderTicket();
            if (tip==OP_BUY)             
            {
               StLo = NormalizeDouble(Bid-TrailingStop*Point,Digits);
               if (StLo > OSL && StLo > OOP)
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("TrailingStop Error ",GetLastError()," buy SL ",OSL,"->",StLo);
               }
            }                                         
            if (tip==OP_SELL)        
            {
               StLo = NormalizeDouble(Ask+TrailingStop*Point,Digits);
               if (StLo > OOP || StLo==0) continue;
               if (StLo < OSL || OSL==0 )
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("TrailingStop Error ",GetLastError()," sell SL ",OSL,"->",StLo);
               }
            } 
         }
      }
   }
}
//--------------------------------------------------------------------
void NoLoss()
{
   int tip,Ticket;
   double StLo,OSL,OOP;
   for (int i=0; i<OrdersTotal(); i++) 
   {  if (OrderSelect(i, SELECT_BY_POS))
      {  tip = OrderType();
         if (tip<2 && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            OSL   = NormalizeDouble(OrderStopLoss(),Digits);
            OOP   = NormalizeDouble(OrderOpenPrice(),Digits);
            Ticket = OrderTicket();
            if (tip==OP_BUY)             
            {
               if (OSL>OOP) continue;
               StLo = NormalizeDouble(OOP+Point,Digits);
               if (NormalizeDouble((Bid-OOP)/Point,0)>=NoLoss)
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("NoLoss Error ",GetLastError()," buy SL ",OSL,"->",StLo);
               }
            }                                         
            if (tip==OP_SELL)        
            {
               if (OSL<OOP) continue;
               StLo = NormalizeDouble(OOP-Point,Digits);
               if (NormalizeDouble((OOP-Ask)/Point,0)>=NoLoss)
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("NoLoss Error ",GetLastError()," sell SL ",OSL,"->",StLo);
               }
            } 
         }
      }
   }
}
//--------------------------------------------------------------------

